# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Batch::Mgmt::V2019_08_01
  module Models
    #
    # Information used to connect to an Azure Fileshare.
    #
    #
    class AzureFileShareConfiguration

      include MsRestAzure

      # @return [String] The Azure Storage account name.
      attr_accessor :account_name

      # @return [String] The Azure Files URL. This is of the form
      # 'https://{account}.file.core.windows.net/'.
      attr_accessor :azure_file_url

      # @return [String] The Azure Storage account key.
      attr_accessor :account_key

      # @return [String] The relative path on the compute node where the file
      # system will be mounted. All file systems are mounted relative to the
      # Batch mounts directory, accessible via the AZ_BATCH_NODE_MOUNTS_DIR
      # environment variable.
      attr_accessor :relative_mount_path

      # @return [String] Additional command line options to pass to the mount
      # command. These are 'net use' options in Windows and 'mount' options in
      # Linux.
      attr_accessor :mount_options


      #
      # Mapper for AzureFileShareConfiguration class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureFileShareConfiguration',
          type: {
            name: 'Composite',
            class_name: 'AzureFileShareConfiguration',
            model_properties: {
              account_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'accountName',
                type: {
                  name: 'String'
                }
              },
              azure_file_url: {
                client_side_validation: true,
                required: true,
                serialized_name: 'azureFileUrl',
                type: {
                  name: 'String'
                }
              },
              account_key: {
                client_side_validation: true,
                required: true,
                serialized_name: 'accountKey',
                type: {
                  name: 'String'
                }
              },
              relative_mount_path: {
                client_side_validation: true,
                required: true,
                serialized_name: 'relativeMountPath',
                type: {
                  name: 'String'
                }
              },
              mount_options: {
                client_side_validation: true,
                required: false,
                serialized_name: 'mountOptions',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
