# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Batch::Mgmt::V2019_08_01
  module Models
    #
    # Contains information about an Azure Batch account.
    #
    class BatchAccount < Resource

      include MsRestAzure

      # @return [String] The account endpoint used to interact with the Batch
      # service.
      attr_accessor :account_endpoint

      # @return [ProvisioningState] The provisioned state of the resource.
      # Possible values include: 'Invalid', 'Creating', 'Deleting',
      # 'Succeeded', 'Failed', 'Cancelled'
      attr_accessor :provisioning_state

      # @return [PoolAllocationMode] The allocation mode to use for creating
      # pools in the Batch account. Possible values include: 'BatchService',
      # 'UserSubscription'
      attr_accessor :pool_allocation_mode

      # @return [KeyVaultReference] A reference to the Azure key vault
      # associated with the Batch account.
      attr_accessor :key_vault_reference

      # @return [AutoStorageProperties] The properties and status of any
      # auto-storage account associated with the Batch account.
      attr_accessor :auto_storage

      # @return [Integer] The dedicated core quota for the Batch account. For
      # accounts with PoolAllocationMode set to UserSubscription, quota is
      # managed on the subscription so this value is not returned.
      attr_accessor :dedicated_core_quota

      # @return [Integer] The low-priority core quota for the Batch account.
      # For accounts with PoolAllocationMode set to UserSubscription, quota is
      # managed on the subscription so this value is not returned.
      attr_accessor :low_priority_core_quota

      # @return [Array<VirtualMachineFamilyCoreQuota>] A list of the dedicated
      # core quota per Virtual Machine family for the Batch account. For
      # accounts with PoolAllocationMode set to UserSubscription, quota is
      # managed on the subscription so this value is not returned.
      attr_accessor :dedicated_core_quota_per_vmfamily

      # @return [Boolean] A value indicating whether the core quota for the
      # Batch Account is enforced per Virtual Machine family or not. Batch is
      # transitioning its core quota system for dedicated cores to be enforced
      # per Virtual Machine family. During this transitional phase, the
      # dedicated core quota per Virtual Machine family may not yet be
      # enforced. If this flag is false, dedicated core quota is enforced via
      # the old dedicatedCoreQuota property on the account and does not
      # consider Virtual Machine family. If this flag is true, dedicated core
      # quota is enforced via the dedicatedCoreQuotaPerVMFamily property on the
      # account, and the old dedicatedCoreQuota does not apply.
      attr_accessor :dedicated_core_quota_per_vmfamily_enforced

      # @return [Integer] The pool quota for the Batch account.
      attr_accessor :pool_quota

      # @return [Integer] The active job and job schedule quota for the Batch
      # account.
      attr_accessor :active_job_and_job_schedule_quota


      #
      # Mapper for BatchAccount class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BatchAccount',
          type: {
            name: 'Composite',
            class_name: 'BatchAccount',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              account_endpoint: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.accountEndpoint',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'Enum',
                  module: 'ProvisioningState'
                }
              },
              pool_allocation_mode: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.poolAllocationMode',
                type: {
                  name: 'Enum',
                  module: 'PoolAllocationMode'
                }
              },
              key_vault_reference: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.keyVaultReference',
                type: {
                  name: 'Composite',
                  class_name: 'KeyVaultReference'
                }
              },
              auto_storage: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.autoStorage',
                type: {
                  name: 'Composite',
                  class_name: 'AutoStorageProperties'
                }
              },
              dedicated_core_quota: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.dedicatedCoreQuota',
                type: {
                  name: 'Number'
                }
              },
              low_priority_core_quota: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.lowPriorityCoreQuota',
                type: {
                  name: 'Number'
                }
              },
              dedicated_core_quota_per_vmfamily: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.dedicatedCoreQuotaPerVMFamily',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'VirtualMachineFamilyCoreQuotaElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'VirtualMachineFamilyCoreQuota'
                      }
                  }
                }
              },
              dedicated_core_quota_per_vmfamily_enforced: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.dedicatedCoreQuotaPerVMFamilyEnforced',
                type: {
                  name: 'Boolean'
                }
              },
              pool_quota: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.poolQuota',
                type: {
                  name: 'Number'
                }
              },
              active_job_and_job_schedule_quota: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.activeJobAndJobScheduleQuota',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
